SystemOrganization addCategory: #TusLibros!

Object subclass: #Cajero
	instanceVariableNames: 'libroDeVentas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cajero class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/2/2013 19:18'!
emptyCarritoError
	^self error: self emptyCarritoMessage.! !

!Cajero class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/2/2013 19:14'!
emptyCarritoMessage
	^'No se puede vender un carrito vacio'.! !

!Cajero methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 00:39'!
checkout: unCarrito
	| acumulador |
	(unCarrito isEmpty) ifTrue: [self class emptyCarritoError].
	acumulador := 0.
	unCarrito contents do: [ :unLibro |
		acumulador :=
		( acumulador + 	( (unCarrito catalogo at: unLibro) ) )
	].
	^acumulador.! !

!Cajero methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/2/2013 19:13'!
initialize
	libroDeVentas := OrderedCollection new.! !

!Cajero methodsFor: 'accessing' stamp: 'SebastianGarbi 6/2/2013 19:19'!
libroDeVentas
	^ libroDeVentas! !

Object subclass: #Carrito
	instanceVariableNames: 'catalogo canasto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:58'!
invalidElementError
	self error: self invalidElementMessage.! !

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:22'!
invalidElementMessage
	^'No se puede agregar algo que no pertenece al catalogo'.! !

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:17'!
newWithThisCatalog: aCatalog
	^self new initializeWith: aCatalog. ! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:55'!
add: unElemento
	
	self add: 1 of: unElemento.
! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/2/2013 19:28'!
add: aSmallInteger of: anObject 
	"(catalogo includes: anObject) ifFalse: [self class invalidElementError]."
	catalogo at: anObject ifAbsent: [self class invalidElementError].
	canasto add: anObject  withOccurrences: aSmallInteger.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:43'!
amountOf: anObject 
	^canasto occurrencesOf: anObject .! !

!Carrito methodsFor: 'accessing' stamp: 'SebastianGarbi 6/2/2013 23:46'!
catalogo
	^ catalogo! !

!Carrito methodsFor: 'accessing' stamp: 'SebastianGarbi 6/2/2013 23:46'!
contents
	^canasto.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:41'!
includes: anObject 
	^canasto includes: anObject .! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:18'!
initialize 
	canasto := Bag new.

	^self.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:18'!
initializeWith: aCatalog 
	
	catalogo := aCatalog .
	^self.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:35'!
isEmpty
	^canasto isEmpty.! !

!Carrito methodsFor: 'accessing' stamp: 'SebastianGarbi 6/3/2013 00:22'!
quantityOf: unObjeto
	^canasto occurrencesOf: unObjeto.
	! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:49'!
size
	^canasto size.! !

TestCase subclass: #EditorialTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/2/2013 19:11'!
cajero
	^Cajero new.! !

!EditorialTest methodsFor: 'carritoIntansce' stamp: 'SebastianGarbi 6/2/2013 18:57'!
carrito
	|catalogo|
	catalogo := self catalogoConLibro: self libro.
	^Carrito newWithThisCatalog: catalogo.
	! !

!EditorialTest methodsFor: 'carritoIntansce' stamp: 'SebastianGarbi 5/29/2013 21:26'!
carrito: unCatalogo
	^Carrito newWithThisCatalog: unCatalogo.
	! !

!EditorialTest methodsFor: 'catalogo' stamp: 'SebastianGarbi 6/2/2013 19:22'!
catalogo
	^Dictionary new.! !

!EditorialTest methodsFor: 'catalogo' stamp: 'SebastianGarbi 6/2/2013 19:26'!
catalogoConLibro: unLibro
	| catalogo |
	catalogo := self catalogo.
	"catalogo add: unLibro ."
	catalogo at: unLibro put: 10. 
	^catalogo.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'SebastianGarbi 6/2/2013 18:49'!
libro
	^'un libro'.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'SebastianGarbi 6/2/2013 18:50'!
libroDeOtroCatalogo
	^'libro de otro catalogo'.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'SebastianGarbi 6/2/2013 18:50'!
otroLibro
	^'otro libro'.! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 5/27/2013 21:09'!
test01CarritoShouldBeEmptyAfterCreation
	self assert: (self carrito isEmpty). ! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/2/2013 18:53'!
test02CarritoMustHaveABookAfterAdding
	|unCarrito unLibro unNumero unCatalogo|
	unLibro := self libro.
	"unCatalogo := self catalogo."
	"unCatalogo add: unLibro."
	"unCarrito := self carrito: unCatalogo."
	unNumero := 1.
	unCarrito := self carrito.
		
	unCarrito add:  unNumero of: unLibro . 
	self deny:  (unCarrito ) isEmpty. 
	self assert:  (unCarrito includes: unLibro). 
	self assert:  ((unCarrito amountOf: unLibro) = unNumero).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/2/2013 18:59'!
test03CanIncreaseBookQuantity
	|unCarrito unLibro unNumero unCatalogo |
	
	unLibro := self libro.
	unCarrito  := self carrito.
"	unCatalogo := self catalogo.
	unCatalogo add: unLibro.
	unCarrito := self carrito: unCatalogo.
"	unNumero := 1.
	
	
	unCarrito add: unNumero of: unLibro   .
	unCarrito add: unNumero of: unLibro   .

	 
	self assert:  ((unCarrito amountOf: unLibro) = (unNumero * 2)).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/2/2013 19:30'!
test04CanAddDifferentBooks
	|unCarrito unLibro otroLibro unNumero unCatalogo |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalogo.
	"unCatalogo add: unLibro.
	unCatalogo add: otroLibro."
	unCatalogo at: unLibro put: 10.
	unCatalogo at: otroLibro  put: 20.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: unNumero of: otroLibro  .
	
	
	 
	self assert: (unCarrito includes: unLibro).
	self assert: (unCarrito includes: otroLibro).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/2/2013 19:32'!
test05AddingDifferentBooksRespectQuantities
	|unCarrito unLibro otroLibro unNumero otroNumero unCatalogo |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalogo.
	"unCatalogo add: unLibro.
	unCatalogo add: otroLibro."
	unCatalogo at: unLibro put: 10.
	unCatalogo at: otroLibro  put: 20.
	unCarrito := self carrito: unCatalogo.

	
	
	unNumero := 5.
	otroNumero := 4.
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: otroNumero of: otroLibro  .
	
	
	
	 
	self assert: (unCarrito amountOf: unLibro ) = unNumero .
	self assert: (unCarrito amountOf: otroLibro) = otroNumero .
	
	self assert: unCarrito size = (unNumero + otroNumero ).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/2/2013 19:06'!
test06CarritoCanOnlyTakeCatalogBooks
	|unCarrito|
	unCarrito := self carrito .
	self should: [
		unCarrito add: self libroDeOtroCatalogo.
		self fail
		]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError  messageText  = Carrito invalidElementMessage . 
			self assert:  unCarrito isEmpty . 
		].
	
! !

!EditorialTest methodsFor: '02- Cajero' stamp: 'SebastianGarbi 6/2/2013 19:19'!
test07CajeroNoDebeVenderUnCarritoVacio
	| unCarrito unCajero |
	unCarrito := self carrito.
	unCajero := self cajero.
	self should: [
		unCajero checkout: unCarrito .
		self fail
		]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError  messageText  = Cajero emptyCarritoMessage. 
			self assert:  unCajero libroDeVentas isEmpty . 
		].
	! !

!EditorialTest methodsFor: '02- Cajero' stamp: 'SebastianGarbi 6/3/2013 00:36'!
test08CajeroDebeCobrarCorrecto
	| unCarrito unCajero otroLibro unCatalogo unLibro |
	unLibro := self libro.
	otroLibro := self otroLibro.
	unCatalogo := self catalogo.
	unCatalogo at: unLibro put: 10.
	unCatalogo at: otroLibro put: 30.
	unCarrito := self carrito: unCatalogo.
	unCajero := self cajero.
	unCarrito add: 2 of: unLibro.
	unCarrito add: 	1of: otroLibro.

	unCarrito quantityOf: unLibro.
	unCarrito quantityOf: otroLibro.
	unCatalogo at: unLibro.
	unCatalogo at: otroLibro .		
		
	self assert: (unCajero checkout: unCarrito) = 50.
	! !
